ComSpec <- 
function(
ComSpecdata = 1,
database = 1,
countMS = 5,
MScalib = 1,
HRketa = 0.01,
HRketafluc= 3,
phase.shift = 0,
MPeriod = 4,
MSmode = "HRscan",
MSthrethold = 0,
diment = 1)
{


if (MSmode=="HRscan"){
	MScalib <- MScalib*HRketa*HRketafluc
}
if (MSmode=="HRscan"){
	keta <- ceiling(abs(log10(MScalib))) 
} else {
	keta <-0
}
if (MSmode=="HRscan"){
	MScalib.seq <- seq((-MScalib),MScalib,HRketa )
} else {
	MScalib.seq <- seq((-MScalib),MScalib,MScalib )
}

MSwind.range <- seq(-MScalib,MScalib,HRketa)
palpha <- HRketa*0.1
tolv <- MScalib + palpha 


if (diment==1){
	gc1function <- 1
	oneline.box.sum <- 0
} else {
	gc1function <- 0
}
defaultSamRate <- 16
if (class(ComSpecdata) == "ncdf4") {
	flag <- ncvar_get(ComSpecdata, "flag_count")
	scantime <- ncvar_get(ComSpecdata, "scan_acquisition_time")
	scannum <- ncvar_get(ComSpecdata, "actual_scan_number")
	medmsmax <- ncvar_get(ComSpecdata, "mass_range_max")
	medmsmin <- ncvar_get(ComSpecdata, "mass_range_min")
	ionid <- ncvar_get(ComSpecdata, "scan_index")
	eachscannum <- ncvar_get(ComSpecdata, "point_count")
	MStotint <- ncvar_get(ComSpecdata, "total_intensity")
	MSvalue <- ncvar_get(ComSpecdata, "mass_values")
	MSint <- ncvar_get(ComSpecdata, "intensity_values")
} else {
	scantime <- c(1, 2, 3)
	scannum <- c(10, 20, 30)
	eachscannum <- c(1, 2, 3)
	MStotint <- c(10, 20, 30)
	MSvalue <- c(10, 20, 30)
	MSint <- c(10, 20, 30)
}
Timepara <- scantime[which(abs(eachscannum) < .Machine$integer.max)]
RTini <- min(Timepara)/60
RTruntime <- max(Timepara)/60 - RTini
SamRate <- 1/(mean(Timepara[2:length(Timepara)] - Timepara[1:(length(Timepara) - 1)]))
pixelnum <- length(scannum)
maxscannum <- max(eachscannum)
minscannum <- min(eachscannum)
MSdatabox <- matrix(0, pixelnum, maxscannum + 1)
MSvaluebox <- MSdatabox
MSintbox <- MSdatabox

for (inum in 1:pixelnum) {
	if (abs(eachscannum[inum]) < .Machine$integer.max) {
		initial <- sum(eachscannum[1:inum]) - eachscannum[inum] + 1
		acqrange <- initial:(initial + eachscannum[inum] - 1)
		if (eachscannum[inum] == 0){
			acqrange <- 0
		}
		remainrep <- rep(0, maxscannum - eachscannum[inum] + 1)
		MSvaluebox[inum, ] <- c(MSvalue[acqrange], remainrep)
		MSintbox[inum, ] <- c(MSint[acqrange], remainrep)
	}
}
rownames(MSvaluebox) <- 1:(pixelnum)
rownames(MSintbox) <- 1:(pixelnum)
MSintbox[which(MSintbox < MSthrethold)] <- 0
MSvaluebox[which(MSintbox < MSthrethold)] <- 0
MSintbox <- replace(MSintbox, is.na(MSintbox), 1)
MSvaluebox <- replace(MSvaluebox, is.na(MSvaluebox), 1)

Count.MS <- countMS		
Count.MS.seq <- 17:(17+Count.MS-1)
area.get <- "st.sum"
SumMSnum <- countMS
Sum.MS <- SumMSnum
Sum.MS.seq <- 17:(17+Sum.MS-1) 
if(Count.MS==0){
	use.Count.MS <- "nonMS"
}else if (Count.MS==1){
	use.Count.MS <- "SingleMS"
}else if (Count.MS>=2){
	use.Count.MS <- paste(Count.MS,"MS",sep="")
}


row <- round(SamRate*MPeriod)
col <- round(length(scantime)/row)


res.case <- matrix(0,pixelnum,1)
rownames(res.case) <- 1:pixelnum
res.box0 <- matrix(0,pixelnum,1)



Count.MS.ratio <- paste("MSvaluebox1[which(  MSvaluebox<=(database.num[1]","+(",MScalib,"))&MSvaluebox>=(database.num[1]","-(",MScalib,")) )] <-( MSvaluebox[which(  MSvaluebox<=(database.num[1]","+(",MScalib,"))&MSvaluebox>=(database.num[1]","-(",MScalib,")) )] );  ",collapse="",sep="")
Count.MS.ratio <- paste( substr(Count.MS.ratio,1,(nchar(Count.MS.ratio)-3)),sep="")
colmatcat <- paste("which( ((MSvaluebox[repcol,]<=database.num[1]+(MScalib))&(MSvaluebox[repcol,]>=database.num[1]-(MScalib))) ) ")

box.multipro <- "rowSums(MSvaluebox1)"
datavector <- paste("database.num[1]+",MScalib.seq,",",collapse="", sep="")
datavector <- paste(substr(datavector,1,(nchar(datavector))-1),sep="" )

if (length(Count.MS.seq)>1 ){
	for (isn in 2:length(Count.MS.seq) ){
		Count.MS.ratio.pre <- paste( "MSvaluebox",isn,"[which(  MSvaluebox<=(database.num[",isn,"]+(",MScalib,"))&MSvaluebox>=(database.num[",isn,"]-(",MScalib,")) )] <-( MSvaluebox[which(  MSvaluebox<=(database.num[",isn,"]+(",MScalib,"))&MSvaluebox>=(database.num[",isn,"]-(",MScalib,")) )] ); ",collapse="",sep="")
		Count.MS.ratio.pre <- paste(substr(Count.MS.ratio.pre,1,(nchar(Count.MS.ratio.pre)-2)),sep="" )
		Count.MS.ratio <- paste(  Count.MS.ratio,";",Count.MS.ratio.pre )
		colmatcat.pre <- paste("which( ((MSvaluebox[repcol,]<=database.num[",isn,"]+(MScalib))&(MSvaluebox[repcol,]>=database.num[",isn,"]-(MScalib))) )")
		colmatcat <- paste(  colmatcat,",",colmatcat.pre )
		box.multipro <- paste( box.multipro,"*","rowSums(MSvaluebox",isn,")",sep="" )
	}
}
colmatcat <- paste("c(",substr(colmatcat,1,(nchar(colmatcat)-0)),")" )

MSvaluebox.ext <- matrix(-1,length(MSvaluebox[,1]),length(MSvaluebox[1,]) )
MSintbox.ext <- matrix(0,length(MSvaluebox[,1]),length(MSvaluebox[1,]) )
MSvaluebox.extfreshpre <- MSvaluebox.ext
MSintbox.extfreshpre <- MSintbox.ext

int.result <- matrix(0,length(database[,1])/2,2)
int.result[,1] <- paste(database[seq(1,length(database[,1]),2),2])
try(for (i in seq(1,length(database[,1]),2)  ){
	for ( roc in 1:length(Count.MS.seq) ){
		eval(parse(text=paste("MSvaluebox",roc," <- MSintbox.extfreshpre", sep="") ))
	}

	MSvaluebox.extfresh <- MSvaluebox.extfreshpre
	MSintbox.extfresh <- MSintbox.extfreshpre
	database.num <- as.numeric( round(database[i,Count.MS.seq],digits=keta) )
	eval(parse(text=paste(Count.MS.ratio)))
	mat.prod <- eval(parse(text=paste(box.multipro)))
	if (sum(mat.prod)>0){
		rowmat <-which(mat.prod!=0)
		int.value.integ <- 0
		for (repcol in rowmat ){
			colmat <- eval(parse(text=paste(colmatcat)))
			MSintbox.extfresh[repcol,colmat ] <- MSintbox[repcol,colmat ]
			MSvaluebox.extfresh[repcol,colmat ] <- MSvaluebox[repcol,colmat ]
			MSintbox.ext[repcol,colmat ] <- MSintbox[repcol,colmat  ]
			MSvaluebox.ext[repcol,colmat ] <- MSvaluebox[repcol,colmat  ]
			quant.id <- matrix(0,1,length(Sum.MS.seq))
			for (iq in 1:length(Sum.MS.seq) ){		
				quant.id[iq] <- which(MSintbox.ext[repcol,colmat]== max(MSintbox.ext[repcol,colmat][
				which(( MSvaluebox.ext[repcol, colmat] >= as.numeric(round(database[i,Sum.MS.seq][iq],digits=keta) - MScalib ) ) & (MSvaluebox.ext[repcol, colmat] <= as.numeric(round(database[i,Sum.MS.seq][iq],digits=keta) + MScalib ))  ) ])[1])
			}
		
			minratioMSid <- which( (MSintbox.ext[repcol, colmat][quant.id] / database[i+1,Sum.MS.seq])== min( MSintbox.ext[repcol, colmat][quant.id] / database[i+1,Sum.MS.seq] ) )[1]
			int.value <- max(MSintbox.ext[repcol,colmat][quant.id][minratioMSid]*(database[i+1,Sum.MS.seq] / as.numeric(database[i+1,Sum.MS.seq][minratioMSid])))[1]
			int.value.integ <- int.value + int.value.integ
		}
		int.result[(i+1)/2,2] <- int.value.integ
		int.result[(i+1)/2,1] <- paste(database[i,2])
	} #endif

	if (diment==1){
		dev.new(width = 8, height = 4)
		par(mar = c(5, 7, 1, 1))
		if (i > 1) {
			dev.off()
		}

		xaxis <- (1:pixelnum)/SamRate/60 + RTini
		plot(xaxis,rowSums(MSintbox.extfresh),xlab="Retention time (min)",ylab="Intensity",ty="l" )
		text( RTini*1.5,max( rowSums(MSintbox.extfresh) ), paste(database[i,2]) )
		dev.copy(jpeg,paste(savefilename,"terrainEIC_","_",2*i-1,"MS",countMS,".jpeg",sep=""),width=960,height=480)
		dev.off()
		dev.off()
	}

	if (diment==2){
		res.box <- as.matrix(rowSums(MSintbox.extfresh))
		redidu <- row-SamRate*MPeriod
		redidu.accum <-0
		blank.id <- round(phase.shift*SamRate+1)
		cont.num<-0
		mat <- matrix(1,row,col)

		try(for (u in round(phase.shift*SamRate+1):(length(res.box[,1])+round(phase.shift*SamRate)) ){
			if (u%%row==0){
				redidu.accum <-redidu.accum + redidu
			}
			if ( redidu.accum > 1  ){
				blank.id <- blank.id +1
				mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
				blank.id <- blank.id +1
				mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
				redidu.accum <- redidu.accum -1 
			} else {
				blank.id <- blank.id +1
				mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
			}
		})

		zz1 <- t(apply(as.matrix(mat[1:nrow(mat),1:ncol(mat)]),2,rev))
		xx1 <- (1:nrow(zz1))/col*RTruntime+RTini
		yy1 <-(((1:ncol(zz1))/row*MPeriod))
		max.zz<-max(zz1)

		windows(width=10,height=5)
		par(mar=c(5,7,1,1))
		filled.contour(xx1,yy1,zz1,xlab="GC1 (min)",ylab="GC2 (sec)",col=terrain.colors(30),levels=seq(0,max(res.box/10)+0.1,max(res.box/10)/30+0.1) )
		text( RTini*1.5,MPeriod*0.95, paste(database[i,2]) )
		dev.copy(jpeg,paste(savefilename,"terrainEIC_","_",2*i-1,"MS",countMS,".jpeg",sep=""),width=960,height=480)
		dev.off()
		dev.off()
	} #endif diment==2

}) #next i

colnames(int.result) <- c("Chemical Group","Total Intensity")
write.csv(int.result,paste(savefilename,"intensity_integrate.csv",sep="") )

if (diment==1){
	dev.new(width = 8, height = 4)
	par(mar = c(5, 7, 1, 1))
	if (i > 1) {
		dev.off()
	}
	xaxis <- (1:pixelnum)/SamRate/60 + RTini
	plot(xaxis,rowSums(MSintbox.ext),xlab="Retention time (min)",ylab="Intensity",ty="l" )
	text( RTini*1.5,max( rowSums(MSintbox.ext) ), "Combined EIC" )
	dev.copy(jpeg,paste(savefilename,"terrainEIC_","SumMSnum",SumMSnum,".jpeg",sep=""),width=960,height=480)
	dev.off()
	dev.off()
}

if (diment==1){
	tic.box <- as.matrix( MStotint  )
	plot(xaxis,tic.box,xlab="Retention time (min)",ylab="Intensity",ty="l" )
	text( RTini*1.5,max( tic.box ), "TIC")
	dev.copy(jpeg,paste(savefilename,"terrainTIC_",".jpeg",sep=""),width=960,height=480)
	dev.off()
	dev.off()
}

if (diment==2){
	res.box <- as.matrix(rowSums(MSintbox.ext))
	redidu <- row-SamRate*MPeriod
	redidu.accum <-0
	blank.id <- round(phase.shift*SamRate+1)
	cont.num<-0
	mat <- matrix(1,row,col)

	try(for (u in round(phase.shift*SamRate+1):(length(res.box[,1])+round(phase.shift*SamRate)) ){
		if (u%%row==0){
			redidu.accum <-redidu.accum + redidu
		}
		if ( redidu.accum > 1  ){
			blank.id <- blank.id +1
			mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
			blank.id <- blank.id +1
			mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
			redidu.accum <- redidu.accum -1 
		} else {
		blank.id <- blank.id +1
		mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- res.box[round(u-phase.shift*SamRate),]
		}
	})

	zz1 <- t(apply(as.matrix(mat[1:nrow(mat),1:ncol(mat)]),2,rev))
	xx1 <- (1:nrow(zz1))/col*RTruntime+RTini
	yy1 <-(((1:ncol(zz1))/row*MPeriod))
	max.zz<-max(zz1)

	windows(width=10,height=5)
	par(mar=c(5,7,1,1))
	filled.contour(xx1,yy1,zz1,xlab="GC1 (min)",ylab="GC2 (sec)",col=terrain.colors(30),levels=seq(0,max(res.box/10)+0.1,max(res.box/10)/30+0.1) )
	dev.copy(jpeg,paste(savefilename,"terainEIC_","SumMSnum",SumMSnum,".jpeg",sep=""),width=960,height=480)
	dev.off()
	dev.off()

	redidu <- row-SamRate*MPeriod
	redidu.accum <-0
	blank.id <- round(phase.shift*SamRate+1)
	cont.num<-0
	tic.box <- as.matrix( MStotint  )
	mat <- matrix(1,row,col)

	try(for (u in round(phase.shift*SamRate+1):(length(tic.box[,1])+round(phase.shift*SamRate)) ){
		if (u%%row==0){
			redidu.accum <-redidu.accum + redidu
		}
		if ( redidu.accum > 1  ){
			blank.id <- blank.id +1
			mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
			blank.id <- blank.id +1
			mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
			redidu.accum <- redidu.accum -1 
		} else {
			blank.id <- blank.id +1
			mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
		}
	})

	zz1 <- t(apply(as.matrix(mat[1:nrow(mat),1:ncol(mat)]),2,rev))
	xx1 <- (1:nrow(zz1))/col*RTruntime+RTini
	yy1 <-(((1:ncol(zz1))/row*MPeriod))
	max.zz<-max(zz1)
	windows(width=10,height=5)
	par(mar=c(5,7,1,1))
	filled.contour(xx1,yy1,zz1,xlab="GC1 (min)",ylab="GC2 (sec)",col=terrain.colors(30),levels=seq(0,max(tic.box)+0.1,max(tic.box)/30+0.1) )
	dev.copy(jpeg,paste(savefilename,"terrainTIC_",".jpeg",sep=""),width=960,height=480)
	dev.off()
	dev.off()
} #endif diment=2
} #end of function

